# Code Token Type Taxonomy (CT3)

CT3 is a methodology for refined evaluation of ML-based code completion approaches.

This source code is used in the below papers:

> Kim Tuyen Le, Gabriel Rashidi, and Artur Andrzejak. A Methodology for Refined Evaluation of Neural Code Completion Approaches. In *Special Issue on Programming Language Processing, Data Mining and Knowledge Discovery*.

## Usage

### Requirements

* TensorFlow >= 2.3 (with GPU for training and evaluating)

We published the following files:

### Creating CT3-data

* `ct3\categories.py` contains all functions for determining code token types. Each class in the file defines a category/dimension with corresponding checking functions. You can add/modify dimensions by adding/updating classes and their defined functions.

* `ct3\ctt_tax.py` contains the main class CttTax, which is used to get token type information for a specific token.

* `ct3\tax_encoder.py` is used to encode the code token type information.

* `ct3\dfs_preprocessing.py` is an example of using CT3 to get code token type information for each code token in ASTs in Depth-First Search (DFS) order.

* `ct3\tax.py` is the script used to create the CT3-enhanced dataset for the Python150k dataset.

* `vars_collector.py` is used to collect indices of nodes where variables are defined in an AST.

### Creating a closed vocabulary model

* `closed-vocab\closed_preprocessing_python.py` is used to build the closed vocabulary on the Python100k dataset and to create the input data (`tfrecord` files) on both Python100k and Python50k datasets.

* `closed-vocab\closed_training_python.py` is used to create, train, and evaulate the model on the Python150k dataset.

* `closed-vocab\closed_preprocessing_javascript.py` and `closed-vocab\closed_training_javascript.py` are used on the JavaScript150k dataset and similar to the scripts used on the Python set.

### Creating a open vocabulary model

* `open-vocab\bpe_preprocessing_python.py` is used to build the open vocabulary on the Python100k dataset and to create the input data (*tfrecord* files) on both Python100k and Python50k datasets.

* `open-vocab\bpe_training_python.py` is used to create, train, and evaulate the model on the Python150k dataset.

* `open-vocab\bpe_preprocessing_javascript.py` and `open-vocab\bpe_training_javascript.py` are used on the JavaScript150k dataset and similar to the scripts used on the Python set.

* `open-vocab\bpe_preprocessing_with_token_idx_python.py` is similar to the script `bpe_preprocessing_python.py` but here each code token in the Python150k dataset is assgined a unique node index. We used these data files later to create the comparion log and then to combine with the CT3-data based on node indices.

### Comparison between the closed and open vocabulary models

* `comparison\compare_close_open_vocab_python.py` is used to create a comparion log between the closed and open vocabulary models. Each code token in the Python50k dataset has prediction results using the closed and open vocabularies side by side.

* `comparison\compare_close_open_vocab_javascript.py` is used on the JavaScript50k dataset and similar to the script used on the Python set.

* `comparison\create_comp_log_with_vidx_python.py` is used to create a list of code tokens and corresponding node indices in the same order as the one obtained from the script `compare_close_open_vocab_python.py` with omitted comparison information. The node indices created by this script can be used to map with the CT3-data generated by the scrip `ct3\tax.py`.

We conducted our experiments on the [Python150k dataset](https://www.sri.inf.ethz.ch/py150) and [JavaScript150k dataset](https://www.sri.inf.ethz.ch/js150) (not for CT3-data). Our package, [cosy](https://gitlab.com/Einhornstyle/cosy), is used to download the dataset, handle input data in the form of ASTs, and write to `tfrecord` files.

## CT3-enhanced dataset

We also published a dataset generated by running the script `ct3\tax.py` that has pre-computed token types for each token in the Python150k dataset [here](https://doi.org/10.5281/zenodo.5733013) (DFS order). The dataset can be used in combination with prediction logs from a model to achieve a refined evaluation.